/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'cpu.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.cpu.mode.*;

import static ru.ispras.microtesk.model.cpu.shared.Shared.*;

public final class MOV extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           MOV.class,
           "MOV",
           false,
           new ParamDecls(),
           false,
           false,
           false,
           new Shortcuts()
               .addShortcut(new Info_alu_instr(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        return new MOV();
    }
  }

  private static final class Info_alu_instr extends InfoAndRule {
    Info_alu_instr() {
      super(
        alu_instr.class,
        "MOV",
        true,
        new ParamDecls()
            .declareParam("op1", ArgumentMode.INOUT, OPRNDL.INFO)
            .declareParam("op2", ArgumentMode.IN, OPRNDR.INFO),
        false,
        false, 
        false
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode op1 = (IAddressingMode) getArgument("op1", args);
      final IAddressingMode op2 = (IAddressingMode) getArgument("op2", args);

      return new alu_instr(
            new MOV(),
            op1,
            op2
        );
    }
  }

  public static final IInfo INFO = new Info();

  public MOV()
  {
  }

  @Override
  public String syntax()
  {
      return "mov";
  }

  @Override
  public String image()
  {
      return "10";
  }

  @Override
  public void action()
  {
      DEST.access().store(SRC2.access().load());
  }
}
