/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class add extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           add.class,
           "add",
           false,
           new ParamDecls()
               .declareParam("rd", ArgumentMode.OUT, REG.INFO)
               .declareParam("rs", ArgumentMode.IN, REG.INFO)
               .declareParam("rt", ArgumentMode.IN, REG.INFO),
           false,
           false,
           true,
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

        return new add(rd, rs, rt);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
        instruction.class,
        "add",
        true,
        new ParamDecls()
            .declareParam("rd", ArgumentMode.OUT, REG.INFO)
            .declareParam("rs", ArgumentMode.IN, REG.INFO)
            .declareParam("rt", ArgumentMode.IN, REG.INFO),
        true,
        true, 
        true
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rd = (IAddressingMode) getArgument("rd", args);
      final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);

      return new instruction(
            new add(
                rd,
                rs,
                rt
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rd;
  private final IAddressingMode rs;
  private final IAddressingMode rt;

  public add(IAddressingMode rd, IAddressingMode rs, IAddressingMode rt)
  {
      assert REG.INFO.isSupported(rd);
      assert REG.INFO.isSupported(rs);
      assert REG.INFO.isSupported(rt);

      this.rd = rd;
      this.rs = rs;
      this.rt = rt;
  }

  @Override
  public String syntax()
  {
      return String.format("add %s, %s, %s", rd.syntax(), rs.syntax(), rt.syntax());
  }

  @Override
  public String image()
  {
      return String.format("000000%s%s%s00000100000", rs.image(), rt.image(), rd.image());
  }

  @Override
  public void action()
  {
      temp.access().store(DataEngine.execute(EOperatorID.PLUS, Location.concat(rs.access(), rs.access().bitField(0x1f, 0x1f)).load(), Location.concat(rt.access(), rt.access().bitField(0x1f, 0x1f)).load()));
      if (DataEngine.booleanValue(DataEngine.execute(EOperatorID.NOT_EQ, temp.access().bitField(0x20, 0x20).load(), temp.access().bitField(0x1f, 0x1f).load())))
      {
          mark("overflow");
          exception("IntegerOverflow");
      }
      else
      {
          mark("normal");
          rd.access().store(temp.access().bitField(0x1f, 0x0).load());
      }
  }
}
