/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IOperation;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class instruction extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           instruction.class,
           "instruction",
           true,
           new ParamDecls()
               .declareParam("command", Operations.INFO),
           true,
           true,
           false);
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IOperation command = (IOperation) getArgument("command", args);

        return new instruction(command);
    }
  }

  public static final IInfo INFO = new Info();

  private final IOperation command;

  public instruction(IOperation command)
  {
      assert Operations.INFO.isSupported(command);

      this.command = command;
  }

  @Override
  public String syntax()
  {
      return command.syntax();
  }

  @Override
  public String image()
  {
      return command.image();
  }

  @Override
  public void action()
  {
      GPR.access(0x0).store(DataEngine.coerce(WORD, DataEngine.valueOf(Type.INT(0x1), 0)));
      is_delay_slot.access().store(BRANCH.access().load());
      jump_address.access().store(JMPADDR.access().load());
      BRANCH.access().store(DataEngine.valueOf(Type.INT(0x1), 0));
      JMPADDR.access().store(DataEngine.coerce(WORD, DataEngine.valueOf(Type.INT(0x1), 0)));
      command.action();
      if (DataEngine.intValue(is_delay_slot.access().load()) == 0x1 && DataEngine.intValue(BRANCH.access().load()) == 0x1)
      {
          unpredicted();
      }
      if (DataEngine.intValue(is_delay_slot.access().load()) == 0x1)
      {
          CIA.access().store(jump_address.access().load());
          __CTRL_TRANSFER.set(1);
      }
      else
      {
          CIA.access().store(DataEngine.execute(EOperatorID.PLUS, CIA.access().load(), DataEngine.valueOf(WORD, 0x4)));
      }
  }
}
