/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class lw extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           lw.class,
           "lw",
           false,
           new ParamDecls()
               .declareParam("rt", ArgumentMode.OUT, REG.INFO)
               .declareParam("offset", SHORT)
               .declareParam("address", ArgumentMode.IN, REG.INFO),
           false,
           false,
           false,
           new Shortcuts()
               .addShortcut(new Info_instruction(), "#root")
        );
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final Location offset = (Location) getArgument("offset", args);
        final IAddressingMode address = (IAddressingMode) getArgument("address", args);

        return new lw(rt, offset, address);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
        instruction.class,
        "lw",
        true,
        new ParamDecls()
            .declareParam("rt", ArgumentMode.OUT, REG.INFO)
            .declareParam("offset", SHORT)
            .declareParam("address", ArgumentMode.IN, REG.INFO),
        true,
        true, 
        false
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);
      final IAddressingMode address = (IAddressingMode) getArgument("address", args);

      return new instruction(
            new lw(
                rt,
                offset,
                address
            )
        );
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rt;
  private final Location offset;
  private final IAddressingMode address;

  public lw(IAddressingMode rt, Location offset, IAddressingMode address)
  {
      assert REG.INFO.isSupported(rt);
      assert SHORT.equals(offset.getType());
      assert REG.INFO.isSupported(address);

      this.rt = rt;
      this.offset = offset;
      this.address = address;
  }

  @Override
  public String syntax()
  {
      return String.format("lw %s, %d(%s)", rt.syntax(), offset.load().getRawData().intValue(), address.syntax());
  }

  @Override
  public String image()
  {
      return String.format("100011%s%s%s", address.image(), rt.image(), offset.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      rt.access().store(M.access(DataEngine.intValue(DataEngine.execute(EOperatorID.PLUS, address.access().load(), DataEngine.coerce(WORD, offset.load()))) >> 0x2).load());
  }
}
