/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.instruction.IOperation;
import ru.ispras.microtesk.model.api.instruction.Operation;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.type.*;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.IAddressingMode;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class SLTI extends Operation {
  private static final class Info extends InfoAndRule {
    Info()
    {
        super(
           SLTI.class,
           "SLTI",
           false,
           new ParamDecls()
               .declareParam("rt", ArgumentMode.OUT, R.INFO)
               .declareParam("rs", ArgumentMode.IN, R.INFO)
               .declareParam("imm", SHORT),
           false,
           false,
           false);
    }

    @Override
    public IOperation create(Map<String, Object> args)
    {
        final IAddressingMode rt = (IAddressingMode) getArgument("rt", args);
        final IAddressingMode rs = (IAddressingMode) getArgument("rs", args);
        final Location imm = (Location) getArgument("imm", args);

        return new SLTI(rt, rs, imm);
    }
  }

  public static final IInfo INFO = new Info();

  private final IAddressingMode rt;
  private final IAddressingMode rs;
  private final Location imm;

  public SLTI(IAddressingMode rt, IAddressingMode rs, Location imm)
  {
      assert R.INFO.isSupported(rt);
      assert R.INFO.isSupported(rs);
      assert SHORT.equals(imm.getType());

      this.rt = rt;
      this.rs = rs;
      this.imm = imm;
  }

  @Override
  public String syntax()
  {
      return String.format("SLTI %s, %s, %d", rt.syntax(), rs.syntax(), imm.load().getRawData().intValue());
  }

  @Override
  public String image()
  {
      return String.format("001010%s%s%s", rs.image(), rt.image(), imm.load().getRawData().toString());
  }

  @Override
  public void action()
  {
      rt.access().store(DataEngine.valueOf(Type.INT(0x20), DataEngine.booleanValue(DataEngine.execute(EOperatorID.LESS, rs.access().load(), DataEngine.coerce(LONG, imm.load()))) ? 0x1 : 0x0));
  }
}
